function [H] = Bending_Hessian(T)
  mu = 1;
  theta0 = pi / 2;

  u = [1 0]';
  v = [0 1]';
  I6 = (T * u)' * (T * v);
  I5u = (T * u)' * (T * u);
  I5v = (T * v)' * (T * v);

  thetaH = Theta_Hessian(T);
  thetaP = Theta_PK1(T);
  p = vec(thetaP);

  theta = acos(I6 / (sqrt(I5u) * sqrt(I5v)));
  H = mu * (p * p') + mu * (theta - theta0) * thetaH;
end
