function [H] = Theta_Hessian(T)
  u = [1 0]';
  v = [0 1]';

  I6 = (T * u)' * (T * v);
  I5u = (T * u)' * (T * u);
  I5v = (T * v)' * (T * v);

  TT = [zeros(3,3) eye(3,3);
        eye(3,3) zeros(3,3)];
  TTv = [zeros(3,3) zeros(3,3);
         zeros(3,3) eye(3,3)];
  TTu = [eye(3,3) zeros(3,3);
         zeros(3,3) zeros(3,3)];

  Tu = T * [1 0; 0 0];
  Tv = T * [0 0; 0 1];
  anti = [0 1; 1 0];
  uut = [1 0; 0 0];
  vvt = [0 0; 0 1];
  Ta = T * anti;

  fa = vec(Ta);
  fu = vec(Tu);
  fv = vec(Tv);

  beast = - 1 / (I5u^1.5 * sqrt(I5v)) * (fa * fu' + fu * fa') ...
      - 1 / (sqrt(I5u) * I5v^1.5) * (fa * fv' + fv * fa') ...
      + I6 / (I5u^1.5 * I5v^1.5) * (fu * fv' + fv * fu') ...
      + (3 * I6 / (I5u^2.5 * sqrt(I5v))) * fu * fu' ...
      + (3 * I6 / (sqrt(I5u) * I5v^2.5)) * fv * fv' ...
      + 1 / (sqrt(I5u) * sqrt(I5v)) * TT ...
      - (I6 / (I5u^1.5 * sqrt(I5v))) * TTu ...
      - (I6 / (sqrt(I5u) * I5v^1.5)) * TTv;

  alpha = I6 / (sqrt(I5u) * sqrt(I5v));
  P = (1 / (sqrt(I5u) * sqrt(I5v)) * T * anti - ...
      I6 * (1 / (sqrt(I5v) * I5u^1.5) * T * uut + 1 / (sqrt(I5u) * I5v^1.5) * T * vvt));
  p = vec(P);

  H = -(1 / sqrt(1 - alpha * alpha)) * beast - (alpha / (1 - alpha * alpha)^1.5) * p * p';
end
