function [H] = Theta_Hessian_Analytic(T)
  t0 = T(:,1);
  t1 = T(:,2);
  b = cross(t0,t1);
  b0 = cross(t0,b / norm(b));
  b1 = cross(t1,b / norm(b));

  cosTheta = dot(t0,t1);

  lambdas = zeros(6,1);
  lambdas(1) = (cosTheta - 1) / norm(b);
  lambdas(2) = (cosTheta + 1) / norm(b);
  lambdas(3) = -1;
  lambdas(4) = 1;
  lambdas(5) = -1;
  lambdas(6) = 1;

  z3 = zeros(3,1);
  q0 = (1 / (sqrt(2) * norm(b))) * [b; b];
  q1 = (1 / (sqrt(2) * norm(b))) * [b; -b];
  q2 = 1 / sqrt(2) * [t0 + b0; z3];
  q3 = 1 / sqrt(2) * [t0 - b0; z3];
  q4 = 1 / sqrt(2) * [z3; t1 - b1];
  q5 = 1 / sqrt(2) * [z3; t1 + b1];

  Q = [q0 q1 q2 q3 q4 q5];

  H = Q * diag(lambdas) * Q';
end
