function[final] = Twist_Psi(state, mu, theta0)
%Gets the twisting energy from the state
v0 = state(1:3);
v1 = state(4:6);
v2 = state(7:9);
v3 = state(10:12);

e0 = v0 - v1;
e1 = v2 - v1;
e2 = v3 - v2;

e0proj = e0 - dot(e0,e1)/dot(e1,e1) * e1;
e2proj = e2 - dot(e2,e1)/dot(e1,e1) * e1;
sgn = sign(dot(e0proj,cross(e1,e2proj)));

theta = acos(dot(e0proj,e2proj)/(norm(e0proj)*norm(e2proj)));

final = mu * (sgn*theta - theta0)^2;

end

