function [Final] = dWdX(state)
%d/dx of W Considering projection coefficients as constant
%vertices from state
v0 = state(1:3);
v1 = state(4:6);
v2 = state(7:9);
v3 = state(10:12);
%edges from vertices
e0 = v0 - v1;
e1 = v2 - v1;
e2 = v3 - v2;
%projection coefficients (held constant)
alph = dot(e0,e1)/dot(e1,e1);
bet = dot(e2,e1)/dot(e1,e1);

Final = zeros(9,12);

Final(1,1) = 1;
Final(1,4) = -1 + alph;
Final(1,7) = -alph;
Final(2,2) = 1;
Final(2,5) = -1 + alph;
Final(2,8) = -alph;
Final(3,3) = 1;
Final(3,6) = -1 + alph;
Final(3,9) = -alph;
Final(4,4) = bet;
Final(4,7) = -1 - bet;
Final(4,10) = 1;
Final(5,5) = bet;
Final(5,8) = -1 - bet;
Final(5,11) = 1;
Final(6,6) = bet;
Final(6,9) = -1 - bet;
Final(6,12) = 1;
Final(7,4) = -1;
Final(7,7) = 1;
Final(8,5) = -1;
Final(8,8) = 1;
Final(9,6) = -1;
Final(9,9) = 1;

end

