function [Final] = dWhatdX(state)
%d/dx of twisting W with nonconstant projection weights
%   d/dx of T = (e0 - e0.e1/e1.e1 e1 | e2 - e2.e1/e1.e1 e1 | e1)
%vertices from state
v0 = state(1:3);
v1 = state(4:6);
v2 = state(7:9);
v3 = state(10:12);
%edges from vertices
e0 = v0 - v1;
e1 = v2 - v1;
e2 = v3 - v2;
%block matrices
de0perpdv0 = eye(3,3) - e1*transpose(e1)/dot(e1,e1);
de0perpdv1 = (dot(e0,e1)/dot(e1,e1) - 1)*eye(3,3) - e1/dot(e1,e1)^2 * transpose((2*dot(e0,e1) - dot(e1,e1))*e1 - dot(e1,e1)*e0);
de0perpdv2 = -dot(e0,e1)/dot(e1,e1) * eye(3,3) - e1/dot(e1,e1)^2 * transpose(dot(e1,e1)*e0 - 2*dot(e0,e1)*e1);
de2perpdv1 = dot(e2,e1)/dot(e1,e1) * eye(3,3) - e1/dot(e1,e1)^2 * transpose(2*dot(e2,e1)*e1 - dot(e1,e1)*e2);
de2perpdv2 = -(dot(e2,e1)/dot(e1,e1) + 1)*eye(3,3) + e1/dot(e1,e1)^2 * transpose((2*dot(e2,e1) + dot(e1,e1))*e1 - dot(e1,e1) * e2);
de2perpdv3 = de0perpdv0;
de1dv1 = -eye(3,3);
de1dv2 = eye(3,3);
Final = [de0perpdv0, de0perpdv1, de0perpdv2, zeros(3,3);
              zeros(3,3), de2perpdv1, de2perpdv2, de2perpdv3;
              zeros(3,3), de1dv1, de1dv2, zeros(3,3)];
end

