addpath('./util');
addpath('./Twisting');
materialName = sprintf('Twisting');

fprintf('============================================\n');
fprintf('Running numerical tests for %s\n', materialName);
fprintf('============================================\n');
fprintf('Numerically verifying dWhatdX:\n');
Verify_Twist_W(@Twist_W, @dWhatdX);
fprintf('Numerically comparing dWdX (***THIS SHOULD FAIL***)\n');
Verify_Twist_W(@Twist_W, @dWdX);
fprintf('Numerically verifying position gradient with dWhatdX:\n');
Verify_Position_Derivative(@Twist_Psi, @Twist_PK1, @dWhatdX);
fprintf('Numerically verifying position gradient with dWdX:\n');
Verify_Position_Derivative(@Twist_Psi, @Twist_PK1, @dWdX);
fprintf('Numerically verifying closeness of dWdX vs. dWhatdX in position derivative:\n');
Verify_Close_Derivatives(@Twist_PK1, @dWdX, @dWhatdX)
